﻿Imports System.IO
Imports System.Data
Imports System.Text
Imports System.Data.SqlClient
Imports System.Collections.Generic

Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(sender As Object, e As EventArgs) Handles Me.Load
        If Not IsPostBack Then
            dlContacts.DataSource = Me.GetData()
            dlContacts.DataBind()
        End If
    End Sub

    Private Function GetData() As DataTable
        Dim conString As String = ConfigurationManager.ConnectionStrings("conStr").ConnectionString
        Using con As New SqlConnection(conString)
            Using cmd As New SqlCommand("select top 6 * from customers")
                cmd.Connection = con
                cmd.CommandType = CommandType.Text
                Using sda As New SqlDataAdapter(cmd)
                    Dim ds As New DataSet()
                    sda.Fill(ds)
                    Return ds.Tables(0)
                End Using
            End Using
        End Using
    End Function
    Protected Sub Print(sender As Object, e As EventArgs)
        Dim dt As DataTable = GetData()
        Dim rows As New List(Of DataRow)()
        For Each item As DataListItem In dlContacts.Items
            If Not TryCast(item.FindControl("CheckBox1"), CheckBox).Checked Then
                rows.Add(dt.Rows(item.ItemIndex))
            End If
        Next
        For Each row As DataRow In rows
            dt.Rows.Remove(row)
        Next
        dlContacts.DataSource = dt
        dlContacts.DataBind()
        For Each item As DataListItem In dlContacts.Items
            item.FindControl("CheckBox1").Visible = False
        Next
        Dim sw As New StringWriter()
        Dim hw As New HtmlTextWriter(sw)
        dlContacts.RenderControl(hw)
        Dim html As String = sw.ToString().Replace("""", "'").Replace(System.Environment.NewLine, "")
        Dim sb As New StringBuilder()
        sb.Append("<script type = 'text/javascript'>")
        sb.Append("window.onload = new function(){")
        sb.Append("var printWin = window.open('', '', 'left=0")
        sb.Append(",top=0,width=1000,height=600,status=0');")
        sb.Append("printWin.document.write(""")
        sb.Append(html)
        sb.Append(""");")
        sb.Append("printWin.document.close();")
        sb.Append("printWin.focus();")
        sb.Append("printWin.print();printWin.opener.location.href=printWin.opener.location.href;")
        sb.Append("printWin.close();};")
        sb.Append("</script>")
        ClientScript.RegisterStartupScript(Me.[GetType](), "GridPrint", sb.ToString())
    End Sub

End Class
